#define EJUDGE
#include "testlib.h"
#include <set>
#include <utility>

using namespace std;

int main(int argc, char * argv[])
{
	setName("Moscow 2011. futurama checker");
    registerTestlibCmd(argc, argv);
	set <pair <int, int> > sw;
	pair <int, int> pr;
	int mind[25];
	int i, j, k, m, n, a, b, c;
	for (i=1; i<=20; i++)
		mind[i] = i;
	n = inf.readInt();
	m = inf.readInt();
    for (i=0; i<m; i++) {
		a = inf.readInt();
		b = inf.readInt();
		if ((a < 1) || (a > n - 2) || (b < 1) || (b > n - 2) || (a == b))
	                quitf(_fail, "wrong pair  %d, %d in input file", a, b);
		c = mind[a];
		mind[a] = mind[b];
		mind[b] = c;
		pr.first = a;
		pr.second = b;
		if (sw.find(pr) != sw.end())
	                quitf(_fail, "duplicated swap %d, %d in input file", a, b);
		sw.insert(pr);
		pr.first = b;
		pr.second = a;
		sw.insert(pr);
	}
        a = b = -1;
	while (!ouf.seekEof()) {
		a = ouf.readInt();
                if (a != 0) b = ouf.readInt();
                if (a == 0 && b == -1)
                    quitf(_wa, "No solution");
		if ((a < 1) || (a > n) || (b < 1) || (b > n) || (a == b))
	        quitf(_wa, "incorrect pair %d, %d", a, b);
		pr.first = a;
		pr.second = b;
		if (sw.find(pr) != sw.end())
	        quitf(_wa, "duplicated swap %d, %d", a, b);
		sw.insert(pr);
		pr.first = b;
		pr.second = a;
		sw.insert(pr);
		c = mind[a];
		mind[a] = mind[b];
		mind[b] = c;
	}
	for (i=1; i <= n; i++)
		if (mind[i] != i)
	        quitf(_wa, "mind %d not in owner body", i);
    quitf(_ok, "OK!");
}